﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows;
using Telerik.Windows.Controls;

namespace _279746_ToolBar
{
	public partial class MainPage : UserControl
	{
		public int flag = 0;
		public MainPage()
		{
			InitializeComponent();
			myToolBarTray.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery));

			MyStackPanel1.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			MyStackPanel1.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo), true);
			MyStackPanel2.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			MyStackPanel2.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
			MyStackPanel3.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			MyStackPanel3.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
			MyStackPanel4.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			MyStackPanel4.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));


		}


		// OnDragQuery event handler
		private void OnDragQuery(object sender, DragDropQueryEventArgs e)
		{
			if (e.Options.Status == DragStatus.DragQuery)
			{
				var draggedItem = e.Options.Source;
				
				// Create Arrow Cue
				e.Options.ArrowCue = RadDragAndDropManager.GenerateArrowCue();
				// Set the payload (this is the item that is currently dragged)
				if ((draggedItem as RadToolBar).Items.Count != 0)
				{
					Image img = (draggedItem as RadToolBar).Items[0] as Image;
					e.Options.Payload = img;
					(draggedItem as RadToolBar).Items.Remove(img);
				}
			}
			e.QueryResult = true;
			e.Handled = true;
		}

		// OnDropQuery event handler
		private void OnDropQuery(object sender, DragDropQueryEventArgs e)
		{
			e.QueryResult = true;
			e.Handled = true;
		}

		private void OnDropInfo(object sender, DragDropEventArgs e)
		{
			StackPanel destination = e.Options.Destination as StackPanel;
			if (e.Options.Status == DragStatus.DropComplete)
			{
				int count = 0;
				switch (destination.Tag.ToString())
				{
					case "panel1":
						RadButton rb = new RadButton();
						rb.Content = e.Options.Payload;
						rb.Height = 50;
						rb.Width = 50;
						destination.Children.Add(rb);

						TextBlock Panel2_txt1 = new TextBlock() { Text = String.Format("Button{0} Height",count)};
						TextBlock Panel2_txt2 = new TextBlock() { Text = String.Format("Button{0} Width", count) }; ;
						TextBlock Panel2_txt3 = new TextBlock() { Text = String.Format("Button{0} IsEnabled", count) }; ;
						this.MyStackPanel2.Children.Add(Panel2_txt1);
						this.MyStackPanel2.Children.Add(Panel2_txt2);
						this.MyStackPanel2.Children.Add(Panel2_txt3);

						TextBlock Panel4_txt1 = new TextBlock() { Text = rb.Height.ToString() };
						TextBlock Panel4_txt2 = new TextBlock() { Text = rb.Width.ToString() }; ;
						TextBlock Panel4_txt3 = new TextBlock() { Text = rb.IsEnabled.ToString() }; ;
						this.MyStackPanel4.Children.Add(Panel4_txt1);
						this.MyStackPanel4.Children.Add(Panel4_txt2);
						this.MyStackPanel4.Children.Add(Panel4_txt3);

						count++;

						break;
					case "panel2":
						for (int i = 1, j = 1; i < this.MyStackPanel1.Children.Count && j < destination.Children.Count; ++i, j+=3)
						{
							(destination.Children[j] as TextBlock).Text = (this.MyStackPanel1.Children[i] as RadButton).Height.ToString();
							(destination.Children[j+1] as TextBlock).Text = (this.MyStackPanel1.Children[i] as RadButton).Width.ToString();
							(destination.Children[j+2] as TextBlock).Text = (this.MyStackPanel1.Children[i] as RadButton).IsEnabled.ToString();
						}
						break;
					case "panel3":
						RadTabControl tc = new RadTabControl();
						RadTabItem tab = new RadTabItem(){Header = "Panel3"};
						tab.Content = e.Options.Payload;
						tc.Items.Add(tab);
						destination.Children.Add(tc);
						break;
					case "panel4":

						Button btn = new Button();
						btn.Content = e.Options.Payload;
						destination.Children.Add(btn);
						break;
					default:
						TextBlock txt = new TextBlock() { Text = "Default" };
						destination.Children.Add(txt);
						break;
				}

			}
		}

	}
}
